Bug 903246

Summary: Review Request: python-cpopen - Creates a subprocess in simpler safer manner
Product: [Fedora] Fedora Reporter: Yaniv Bronhaim <bronhaim>
Component: Package ReviewAssignee: Douglas Schilling Landgraf <dougsland>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: rawhideCC: bazulay, danken, dougsland, herrold, iheim, notting, ybronhei
Target Milestone: ---Flags: dougsland: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: python-cpopen-1.2.3-4.el6 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-11-20 12:25:44 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Yaniv Bronhaim 2013-01-23 09:53:22 EST
Spec URL: http://bronhaim.fedorapeople.org/cpopen.spec
SRPM URL: http://bronhaim.fedorapeople.org/python-cpopen-1.0-1.fc17.src.rpm

Description: This package uses C library to create subprocess in python.
This is my first package and I'm seeking a sponsor.

Fedora Account System Username: bronhaim
Comment 1 Michael Schwendt 2013-01-24 13:23:20 EST
Quickstart help:

* http://fedoraproject.org/wiki/Packaging:Guidelines#Python
* http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text
* http://fedoraproject.org/wiki/Packaging:ReviewGuidelines
* http://fedoraproject.org/wiki/Category:Package_Maintainers
* http://fedoraproject.org/wiki/Category:Package_Maintainers#Packaging_Committee

Run "rpmlint -i" on the src.rpm and all built rpms. Some of the reported warnings/errors can be dubious (false positives), however. Be aware of that.


> Spec URL: http://bronhaim.fedorapeople.org/cpopen.spec
> SRPM URL: http://bronhaim.fedorapeople.org/python-cpopen-1.0-1.fc17.src.rpm

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 


> This package uses C library

> %build
> 
> 
> %install

It doesn't build anything in %build, but only in %install. That's odd enough, so it ought to be examined and fixed.


> BuildRequires: python2
> BuildRequires: python-devel

Why the version difference? (even if either one may be a virtual package) It seems just "BuildRequires: python2-devel" is wanted.


> %{python_sitelib}/createprocess.so*

/usr/lib/python2.7/site-packages/ is the wrong Python module path where to store an arch-specific (!) shared library.
Comment 2 Yaniv Bronhaim 2013-02-05 12:25:32 EST
Updated:
http://bronhaim.fedorapeople.org/python-cpopen.spec
http://bronhaim.fedorapeople.org/python-cpopen-1.1-1.fc17.src.rpm

Sorry for the long delay, I very appreciate your response
Thanks.
Comment 3 Michael Schwendt 2013-02-25 04:08:44 EST
You could *really* run "rpmlint -i" on all the rpms as recommended and comment on the output. ;o)

The rather generic name of the shared lib is potentially problematic, because the file is stored in global search path for Python modules and therefore bears a higher risk of causing a conflict. Blocking that path, even for any module Python Standard Lib may want to include in the future, is not nice:

    $ rpmls -p python-cpopen-1.1-1.fc19.x86_64.rpm 
    -rw-r--r--  /usr/lib64/python2.7/site-packages/cpopen-1.1-py2.7.egg-info
    -rw-r--r--  /usr/lib64/python2.7/site-packages/cpopen.py
    -rw-r--r--  /usr/lib64/python2.7/site-packages/cpopen.pyc
    -rw-r--r--  /usr/lib64/python2.7/site-packages/cpopen.pyo
->  -rwxr-xr-x  /usr/lib64/python2.7/site-packages/createprocess.so

That this theory is not too far off can be seen with a repoquery, which shows that there's at least one other python module that uses such a createprocess.so but stores it in a subdir (which is much more nice):

  # repoquery --whatprovides /usr/*python*createprocess.so
  vdsm-python-0:4.10.3-5.gitb005b54.fc19.x86_64

  # repoquery -l vdsm-python|grep create
  /usr/lib64/python2.7/site-packages/vdsm/betterPopen/createprocess.so
Comment 4 Yaniv Bronhaim 2013-03-13 08:57:06 EDT
Updated:
http://bronhaim.fedorapeople.org/python-cpopen.spec
http://bronhaim.fedorapeople.org/python-cpopen-1.2-1.fc17.src.rpm

rpmlint -i python-cpopen.spec :)
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

renamed createprocess to cpopen-createprocess
Comment 5 Yaniv Bronhaim 2013-04-07 04:30:01 EDT
set cpopen-createproess.so permissions to 755

Updated:
http://bronhaim.fedorapeople.org/python-cpopen.spec
http://bronhaim.fedorapeople.org/python-cpopen-1.2.1-1.fc17.src.rpm
Comment 6 Yaniv Bronhaim 2013-05-08 04:58:00 EDT
New update after merging cpopen to project vdsm. The only change is naming the library file to cpopen.

http://bronhaim.fedorapeople.org/python-cpopen-1.2.2-1.fc17.src.rpm
http://bronhaim.fedorapeople.org/python-cpopen.spec
Comment 7 Douglas Schilling Landgraf 2013-06-11 13:43:17 EDT
Hi Yaniv,

Your package looks good but please handle the rpmlint output:

Checking: python-cpopen-1.2.2-1.fc18.x86_64.rpm
python-cpopen.x86_64: W: incoherent-version-in-changelog 1.2.2 ['1.2.2-1.fc18', '1.2.2-1']

Your release looks like wrong:
Release:        1%{?dist}

%changelog
* Wed May 08 2013 Yaniv Bronhaim <ybronhei@redhat.com> 1.2.2

More info:
http://fedoraproject.org/wiki/ParagNemade/CommonRpmlintErrors#incoherent-version-in-changelog

python-cpopen.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/cpopen.so cpopen.so()(64bit)

More info:
http://fedoraproject.org/wiki/Common_Rpmlint_issues#private-shared-object-provides
https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Preventing_files.2Fdirectories_from_being_scanned_for_deps_.28pre-scan_filtering.29

python-cpopen.x86_64: W: no-documentation
You might consider include README, COPYING, AUTHORS into %doc

Also, to be sponsor you need to provide some informal reviews, just point the urls and I will check.

To help on such task you can use:
http://fedoraproject.org/wiki/Packaging:ReviewGuidelines
http://fedoraproject.org/wiki/Packaging:Python
http://fedoraproject.org/wiki/Packaging:Java
https://fedorahosted.org/FedoraReview/

Please let me know if you have any additional questions.

@Michael, thanks for your help here.

Thanks
Douglas
Comment 8 Douglas Schilling Landgraf 2013-06-11 13:45:23 EDT
(In reply to Douglas Schilling Landgraf from comment #7)
> Hi Yaniv,
> 
> Your package looks good but please handle the rpmlint output:
> 
> Checking: python-cpopen-1.2.2-1.fc18.x86_64.rpm
> python-cpopen.x86_64: W: incoherent-version-in-changelog 1.2.2
> ['1.2.2-1.fc18', '1.2.2-1']
> 
> Your release looks like wrong:
> Release:        1%{?dist}
> 
> %changelog
> * Wed May 08 2013 Yaniv Bronhaim <ybronhei@redhat.com> 1.2.2
> 
> More info:
> http://fedoraproject.org/wiki/ParagNemade/CommonRpmlintErrors#incoherent-
> version-in-changelog
> 
> python-cpopen.x86_64: W: private-shared-object-provides
> /usr/lib64/python2.7/site-packages/cpopen.so cpopen.so()(64bit)
> 
> More info:
> http://fedoraproject.org/wiki/Common_Rpmlint_issues#private-shared-object-
> provides
> https://fedoraproject.org/wiki/Packaging:
> AutoProvidesAndRequiresFiltering#Preventing_files.
> 2Fdirectories_from_being_scanned_for_deps_.28pre-scan_filtering.29
> 
> python-cpopen.x86_64: W: no-documentation
> You might consider include README, COPYING, AUTHORS into %doc
> 
> Also, to be sponsor you need to provide some informal reviews, just point
> the urls and I will check.

Just typo from my comment above :s/sponsor/sponsored/g.
http://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

Thanks
Douglas
Comment 9 Douglas Schilling Landgraf 2013-06-11 15:04:35 EDT
You might want also add some more info into your setup.py

Example:
 license='GPLv2+',
 platforms=['Linux'],
 
Cheers
Douglas
Comment 10 Yaniv Bronhaim 2013-06-12 11:57:47 EDT
fixed spec: 
http://bronhaim.fedorapeople.org/python-cpopen-1.2.2-1.fc17.src.rpm
http://bronhaim.fedorapeople.org/python-cpopen.spec

1. fixed changelog dates 
2. added "provides_exclude_from" for shared library
3. added doc files to tar
Comment 11 Douglas Schilling Landgraf 2013-06-13 00:09:03 EDT
Hi Yaniv,

(In reply to Yaniv Bronhaim from comment #10)
> fixed spec: 
> http://bronhaim.fedorapeople.org/python-cpopen-1.2.2-1.fc17.src.rpm
> http://bronhaim.fedorapeople.org/python-cpopen.spec
> 
> 1. fixed changelog dates 
> 2. added "provides_exclude_from" for shared library
> 3. added doc files to tar

Your new spec/src.rpm looks good. Do you have informal reviews to share? 


Thanks
Douglas
Comment 12 Yaniv Bronhaim 2013-08-14 12:53:11 EDT
Adding links to my informal reviews till now:
https://bugzilla.redhat.com/show_bug.cgi?id=956205
https://bugzilla.redhat.com/show_bug.cgi?id=827723
https://bugzilla.redhat.com/show_bug.cgi?id=924675

Planning to have some more.

Thanks.
Comment 13 Douglas Schilling Landgraf 2013-08-14 13:00:39 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[-]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 1 files have unknown
     license. Detailed output of licensecheck in /home/fedora/903246-python-
     cpopen/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-cpopen-1.2.2-1.fc19.x86_64.rpm
python-cpopen.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/cpopen.so cpopen.so()(64bit)
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

%global __provides_exclude_from


Rpmlint (installed packages)
----------------------------
# rpmlint python-cpopen
python-cpopen.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/cpopen.so cpopen.so()(64bit)
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'

I see %global __provides_exclude_from


Requires
--------
python-cpopen (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
python-cpopen:
    cpopen.so()(64bit)
    python-cpopen
    python-cpopen(x86-64)



Source checksums
----------------
http://bronhaim.fedorapeople.org/cpopen-1.2.2.tar.gz :
  CHECKSUM(SHA256) this package     : f0bc92e10988e4737538d3fd44431102febccca4cf8abc084e779c10ae3191e3
  CHECKSUM(SHA256) upstream package : f0bc92e10988e4737538d3fd44431102febccca4cf8abc084e779c10ae3191e3


APPROVED.

Follow the process from: 
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers#Add_Package_to_Source_Code_Management_.28SCM.29_system_and_Set_Owner

If you have any questions please let me know, my irc nickname is dougsland.
Comment 14 Yaniv Bronhaim 2013-08-14 13:15:27 EDT
New Package SCM Request
=======================
Package Name: cpopen
Short Description: Python package for creating sub-process in simpler and safer manner by using C code.
Owners: Yaniv Bronhaim <bronhaim@gmail.com>
Branches: f18 f19 el6
InitialCC: <dougsland@redhat.com>
Comment 15 Yaniv Bronhaim 2013-08-14 13:31:13 EDT
sorry, fixing the fields

New Package SCM Request
=======================
Package Name: python-cpopen
Short Description: Python package for creating sub-process in simpler and safer manner by using C code.
Owners: bronhaim
Branches: f18 f19 el6
InitialCC: dougsland
Comment 16 Jon Ciesla 2013-08-14 14:30:37 EDT
Requested package name python-cpopen doesn't match bug summary cpopen,
please correct.
Comment 17 Yaniv Bronhaim 2013-08-15 11:45:36 EDT
New Package SCM Request
=======================
Package Name: python-cpopen
Short Description: Python package for creating sub-process in simpler and safer manner by using C code.
Owners: bronhaim
Branches: f18 f19 el6
InitialCC: dougsland
Comment 18 Jon Ciesla 2013-08-15 12:10:03 EDT
Git done (by process-git-requests).
Comment 19 Fedora Update System 2013-08-21 10:21:49 EDT
python-cpopen-1.2.2-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.2-1.fc18
Comment 20 Fedora Update System 2013-08-21 10:24:35 EDT
python-cpopen-1.2.2-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.2-1.fc19
Comment 21 Fedora Update System 2013-08-21 10:36:45 EDT
python-cpopen-1.2.2-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.2-1.el6
Comment 22 Fedora Update System 2013-08-25 18:57:55 EDT
python-cpopen-1.2.2-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 23 Fedora Update System 2013-08-26 04:36:29 EDT
python-cpopen-1.2.3-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-1.fc18
Comment 24 Fedora Update System 2013-08-26 05:00:19 EDT
python-cpopen-1.2.3-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-1.el6
Comment 25 Fedora Update System 2013-08-26 06:35:34 EDT
python-cpopen-1.2.3-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-2.el6
Comment 26 Fedora Update System 2013-08-26 06:44:24 EDT
python-cpopen-1.2.3-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-2.fc19
Comment 27 Fedora Update System 2013-08-26 07:18:42 EDT
python-cpopen-1.2.3-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-2.fc18
Comment 28 Fedora Update System 2013-08-26 12:50:21 EDT
python-cpopen-1.2.2-1.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 29 Fedora Update System 2013-10-10 14:34:29 EDT
python-cpopen-1.2.3-2.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 30 Fedora Update System 2013-10-10 22:27:23 EDT
python-cpopen-1.2.3-2.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 31 Fedora Update System 2013-10-10 22:31:45 EDT
python-cpopen-1.2.3-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 32 Yaniv Bronhaim 2013-10-23 10:39:02 EDT
Added updates:
http://bronhaim.fedorapeople.org/python-cpopen-1.2.3-3.fc19.src.rpm
http://bronhaim.fedorapeople.org/python-cpopen.spec

This fix the spec to override old packages' files on conflicts.
Comment 33 Fedora Update System 2013-10-23 13:37:28 EDT
python-cpopen-1.2.3-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-3.el6
Comment 34 Fedora Update System 2013-10-23 14:16:04 EDT
python-cpopen-1.2.3-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-3.fc18
Comment 35 Fedora Update System 2013-10-24 15:08:56 EDT
Package python-cpopen-1.2.3-3.el6:
* should fix your issue,
* was pushed to the Fedora EPEL 6 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing python-cpopen-1.2.3-3.el6'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2013-11941/python-cpopen-1.2.3-3.el6
then log in and leave karma (feedback).
Comment 36 Fedora Update System 2013-11-07 10:17:08 EST
python-cpopen-1.2.3-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-4.fc18
Comment 37 Fedora Update System 2013-11-07 10:18:32 EST
python-cpopen-1.2.3-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-cpopen-1.2.3-4.el6
Comment 38 Fedora Update System 2013-11-20 12:25:44 EST
python-cpopen-1.2.3-4.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 39 Douglas Schilling Landgraf 2014-07-11 13:16:51 EDT
New Package SCM Request
=======================
Package Name: python-cpopen
Short Description: Python package for creating sub-process in simpler and safer 
Owners: bronhaim, dougsland, danken
Branches: el7
InitialCC:
Comment 40 Jon Ciesla 2014-07-11 14:28:04 EDT
Git done (by process-git-requests).